Bug 530283 (CVE-2009-3624) - CVE-2009-3624 kernel: get_instantiation_keyring() should inc the keyring refcount in all cases
Summary: CVE-2009-3624 kernel: get_instantiation_keyring() should inc the keyring refc...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2009-3624
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 531665
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-10-22 06:49 UTC by Eugene Teo (Security Response)
Modified: 2021-11-12 20:01 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-12-21 19:22:49 UTC


Attachments (Terms of Use)

Description Eugene Teo (Security Response) 2009-10-22 06:49:48 UTC
Quoting from the upstream commit:
"The destination keyring specified to request_key() and co. is made available to the process that instantiates the key (the slave process started by /sbin/request-key typically).  This is passed in the request_key_auth struct as the dest_keyring member.

keyctl_instantiate_key and keyctl_negate_key() call get_instantiation_keyring() to get the keyring to attach the newly constructed key to at the end of instantiation.  This may be given a specific keyring into which a link will be made later, or it may be asked to find the keyring passed to request_key().  In the former case, it returns a keyring with the refcount incremented by lookup_user_key(); in the latter case, it returns the keyring from the request_key_auth struct - and does _not_ increment the refcount.

The latter case will eventually result in an oops when the keyring prematurely runs out of references and gets destroyed.  The effect may take some time to show up as the key is destroyed lazily.

To fix this, the keyring returned by get_instantiation_keyring() must always have its refcount incremented, no matter where it comes from."

This was introduced in upstream commit 8bbf4976 (v2.6.29-rc1).

References:
http://git.kernel.org/linus/21279cfa107af07ef985539ac0de2152b9cba5f5
http://twitter.com/spendergrsec/status/4916661870

Comment 2 Fedora Update System 2009-11-05 05:05:48 UTC
kernel-2.6.30.9-96.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/kernel-2.6.30.9-96.fc11

Comment 3 Fedora Update System 2009-11-06 00:03:01 UTC
kernel-2.6.30.9-96.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.